#ifndef MSP_CORE_META_H_
#define MSP_CORE_META_H_

#include <cstddef>

namespace Msp {

template<typename T>
struct RemoveConst
{ typedef T Type; };

template<typename T>
struct RemoveConst<const T>
{ typedef T Type; };


template<typename T>
struct RemoveReference
{ typedef T Type; };

template<typename T>
struct RemoveReference<T &>
{ typedef T Type; };


template<bool c, typename R>
struct EnableIf;

template<typename R>
struct EnableIf<true, R>
{ typedef R Yes; };

template<typename R>
struct EnableIf<false, R>
{ typedef R No; };


/**
Common fragments used in SFINAE-based decider constructs.
*/
struct Sfinae
{
	struct Yes { char c[2]; };
	struct No { char c; };

	template<size_t s>
	struct Evaluate
	{
		enum { value = (s==sizeof(Yes)) };
	};
};

} // namespace Msp

#endif
